/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/codestring.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_codestring.h"
#include "pmc_string.h"
#include "pmc_scalar.h"
#include "pmc_default.h"
#include "codestring.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/codestring.pmc"
/*
Copyright (C) 2007-2010, Parrot Foundation.

=head1 NAME

src/pmc/codestring.pmc - CodeString PMC Class

=head1 DESCRIPTION

C<CodeString> is a class intended to simplify the process of emitting code
strings.  Ideally this will eventually become a form of "CodeBuffer" that is
more efficient than string concatenation, but for now it works well enough for
me.

The primary method for C<CodeString> objects is C<emit>, which appends a line
(or lines) of code to the string according to a format parameter.  The line can
contain substitution markers (ala printf) that indicate where other parameters
to the call should be placed.

Note that C<CodeString> is just a subclass of Parrot's native C<String> class,
so it's easy to combine CodeString objects with other strings outside of the
C<emit> method.

=head2 Methods

=over 4

=cut

*/

#if PARROT_HAS_ICU
#  include <unicode/uchar.h>
#endif

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* HEADERIZER END: static */
#line 64 "./src/pmc/codestring.c"
static  void  Parrot_CodeString_init(PARROT_INTERP, PMC *_self);
static  void  Parrot_CodeString_mark(PARROT_INTERP, PMC *_self);
static  void Parrot_CodeString_nci_emit(PARROT_INTERP, PMC *_self);
static  void Parrot_CodeString_nci_lineof(PARROT_INTERP, PMC *_self);
static  void Parrot_CodeString_nci_unique(PARROT_INTERP, PMC *_self);
static  void Parrot_CodeString_nci_escape(PARROT_INTERP, PMC *_self);
static  void Parrot_CodeString_nci_charname_to_ord(PARROT_INTERP, PMC *_self);
static  void Parrot_CodeString_nci_key(PARROT_INTERP, PMC *_self);
void    Parrot_CodeString_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_CodeString_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_CodeString_get_vtable(PARROT_INTERP);
void    Parrot_CodeString_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_CodeString_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_CodeString_ro_get_vtable(PARROT_INTERP);
static  void 
Parrot_CodeString_init(PARROT_INTERP, PMC *_self)
{
#line 53 "./src/pmc/codestring.pmc"

    interp->vtables[enum_class_String]->init(interp, _self);
    SETATTR_CodeString_linepos(interp, _self, PMCNULL);
    PObj_custom_mark_SET(_self);
#line 87 "./src/pmc/codestring.c"
}
static  void 
Parrot_CodeString_mark(PARROT_INTERP, PMC *_self)
{
#line 69 "./src/pmc/codestring.pmc"

    interp->vtables[enum_class_String]->mark(interp, _self);
    if (PMC_data(_self)) {
        PMC *linepos;

        GETATTR_CodeString_linepos(interp, _self, linepos);

        Parrot_gc_mark_PMC_alive(interp, linepos);
    }
#line 102 "./src/pmc/codestring.c"
}
static  void
Parrot_CodeString_nci_emit(PARROT_INTERP, PMC *_self)
{
#line 421 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 114 "./src/pmc/codestring.pmc"
PMC* _self;
STRING* fmt;
PMC* args;
PMC* hash;

#line 429 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiSPsPns",
            &_self, &fmt, &args, &hash);
#line 433 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 105 "./src/pmc/codestring.pmc"

STRING * const percent     = CONST_STRING(interp, "%");
STRING * const comma       = CONST_STRING(interp, ",");
STRING * const comma_space = CONST_STRING(interp, ", ");
STRING * const newline     = CONST_STRING(interp, "\n");
PMC           *parts       = PMCNULL;
STRING *key, *repl, *S1;
INTVAL pos          = 0;
INTVAL replen       = 0;

while (pos >= 0) {
    pos += replen;
    pos = STRING_index(interp, fmt, percent, pos);
    if (pos < 0)
        break;

    key = STRING_substr(interp, fmt, pos+1, 1);

    if (VTABLE_exists_keyed_str(interp, hash, key)) {
        repl = VTABLE_get_string_keyed_str(interp, hash, key);
    }
    else if (Parrot_str_is_cclass(interp, enum_cclass_numeric, fmt, (UINTVAL)pos + 1)) {
        const INTVAL I0 = Parrot_str_to_int(interp, key);
        repl = VTABLE_get_string_keyed_int(interp, args, I0);
    }
    else if (STRING_equal(interp, key, comma)) {
        repl = Parrot_str_join(interp, comma_space, args);
    }
    else if (STRING_equal(interp, key, percent)) {
        repl = percent;
    }
    else {
        /* No substitution is necessary */
        replen = 2;
        continue;
    }

    fmt    = Parrot_str_replace(interp, fmt, pos, 2, repl);
    replen = Parrot_str_length(interp, repl);
}

GETATTR_CodeString_str_val(interp, _self, S1);

parts = Parrot_pmc_new_init_int(interp, enum_class_FixedStringArray, 3);
VTABLE_set_string_keyed_int(interp, parts, 0, S1);
VTABLE_set_string_keyed_int(interp, parts, 1, fmt);

/* Add a newline if necessary */
if (STRING_length(fmt) > 0
&&  '\n' != STRING_ord(interp, fmt, -1))
    VTABLE_set_string_keyed_int(interp, parts, 2, newline);

S1 = Parrot_str_join(interp, STRINGNULL, parts);
VTABLE_set_string_native(interp, _self, S1);

#line 259 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *_self */
#line 266 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)_self);
    return;
    /*END RETURN PMC *_self */
    }
#line 160 "./src/pmc/codestring.pmc"

#line 440 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 197 "./src/pmc/codestring.c"
}
static  void
Parrot_CodeString_nci_lineof(PARROT_INTERP, PMC *_self)
{
#line 421 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 209 "./src/pmc/codestring.pmc"
PMC* _self;
INTVAL pos;

#line 429 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiI",
            &_self, &pos);
#line 433 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 175 "./src/pmc/codestring.pmc"

PMC    *linepos;
INTVAL  count;
INTVAL  line = 0;

GETATTR_CodeString_linepos(interp, _self, linepos);

/* build the linepos array if we haven't already done so */
if (!linepos || PMC_IS_NULL(linepos)) {
    STRING *str             = NULL;
    INTVAL  eos;
    INTVAL  jpos;

    linepos = Parrot_pmc_new(interp, enum_class_ResizableIntegerArray);
    /* get the string itself */
    GETATTR_CodeString_str_val(interp, _self, str);
    eos  = Parrot_str_length(interp, str);
    /* find the first newline, if any */
    jpos = Parrot_str_find_cclass(interp, enum_cclass_newline,
                                  str, 0, eos);
    while (jpos < eos) {
        ++jpos;
        /* add the start of line position */
        VTABLE_push_integer(interp, linepos, jpos);

        /* treat \r\n as a single newline */
        if (jpos < eos
        && STRING_ord(interp, str, jpos - 1) == 13
        && STRING_ord(interp, str, jpos)     == 10) {
            ++jpos;
        }
        /* search for the next newline */
        jpos = Parrot_str_find_cclass(interp, enum_cclass_newline,
                                      str, jpos, eos);
    }
    /* save the array of line positions */
    SETATTR_CodeString_linepos(interp, _self, linepos);
}

/* Find the line from the array, stop at the first index that is
 * greater than the position we're looking for.  We do a linear
 * search for now, * perhaps a binary search would be better someday.
 */
count = VTABLE_elements(interp, linepos);
while (line < count
      && VTABLE_get_integer_keyed_int(interp, linepos, line) <= pos)
    ++line;

#line 259 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL line */
#line 266 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "I", (INTVAL)line);
    return;
    /*END RETURN INTVAL line */
    }
#line 223 "./src/pmc/codestring.pmc"

#line 440 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 283 "./src/pmc/codestring.c"
}
static  void
Parrot_CodeString_nci_unique(PARROT_INTERP, PMC *_self)
{
#line 421 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 295 "./src/pmc/codestring.pmc"
PMC* _self;
STRING* format;
INTVAL has_fmt;

#line 429 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiSoIp",
            &_self, &format, &has_fmt);
#line 433 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 241 "./src/pmc/codestring.pmc"

static INTVAL counter = 10;
STRING * const counter_as_string = Parrot_str_from_int(interp, counter);
UNUSED(_self);

++counter;

if (!has_fmt) {
    #line 259 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *counter_as_string */
#line 266 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "S", (STRING*)counter_as_string);
    return;
    /*END RETURN STRING *counter_as_string */
    }
#line 249 "./src/pmc/codestring.pmc"

}
else {
    STRING *result = Parrot_str_concat(interp, format, counter_as_string);
    #line 259 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *result */
#line 266 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "S", (STRING*)result);
    return;
    /*END RETURN STRING *result */
    }
#line 253 "./src/pmc/codestring.pmc"

}
#line 440 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 345 "./src/pmc/codestring.c"
}
static  void
Parrot_CodeString_nci_escape(PARROT_INTERP, PMC *_self)
{
#line 421 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 357 "./src/pmc/codestring.pmc"
PMC* _self;
STRING* str;

#line 429 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &_self, &str);
#line 433 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 269 "./src/pmc/codestring.pmc"

STRING *escaped_str  = Parrot_str_escape(interp, str);
STRING * const quote = CONST_STRING(interp, "\x22");
STRING * const x     = CONST_STRING(interp, "\\x");
INTVAL x_pos;
INTVAL is_unicode = 0;
UNUSED(_self);

escaped_str = Parrot_str_concat(interp, quote, escaped_str);
escaped_str = Parrot_str_concat(interp, escaped_str, quote);
x_pos       = STRING_index(interp, escaped_str, x, 0);

if (x_pos != -1) {
    is_unicode = 1;
}
else {
    STRING * const u = CONST_STRING(interp, "\\u");
    const INTVAL u_pos = STRING_index(interp, escaped_str, u, 0);
    if (u_pos != -1)
        is_unicode = 1;
}

if (is_unicode) {
    STRING * const unicode = CONST_STRING(interp, "unicode:");
    escaped_str            = Parrot_str_concat(interp, unicode, escaped_str);
}

#line 259 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *escaped_str */
#line 266 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "S", (STRING*)escaped_str);
    return;
    /*END RETURN STRING *escaped_str */
    }
#line 296 "./src/pmc/codestring.pmc"

#line 440 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 410 "./src/pmc/codestring.c"
}
static  void
Parrot_CodeString_nci_charname_to_ord(PARROT_INTERP, PMC *_self)
{
#line 421 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 422 "./src/pmc/codestring.pmc"
PMC* _self;
STRING* name;

#line 429 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &_self, &name);
#line 433 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 311 "./src/pmc/codestring.pmc"

#if PARROT_HAS_ICU
UErrorCode   err       = U_ZERO_ERROR;
char * const cstr      = Parrot_str_to_cstring(interp, name);
UChar32      codepoint = u_charFromName(U_EXTENDED_CHAR_NAME, cstr, &err);
Parrot_str_free_cstring(cstr);
if (U_SUCCESS(err)) {
    #line 259 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL codepoint */
#line 266 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "I", (INTVAL)codepoint);
    return;
    /*END RETURN INTVAL codepoint */
    }
#line 318 "./src/pmc/codestring.pmc"

}
#line 259 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL -1 */
#line 266 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "I", (INTVAL)-1);
    return;
    /*END RETURN INTVAL -1 */
    }
#line 320 "./src/pmc/codestring.pmc"

#else
Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
    "no ICU lib loaded");
#endif
#line 440 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 471 "./src/pmc/codestring.c"
}
static  void
Parrot_CodeString_nci_key(PARROT_INTERP, PMC *_self)
{
#line 421 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object;

    { /* BEGIN PARMS SCOPE */
#line 483 "./src/pmc/codestring.pmc"
PMC* _self;
PMC* args;

#line 429 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiPs",
            &_self, &args);
#line 433 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 338 "./src/pmc/codestring.pmc"

INTVAL         index;
const INTVAL   elements      = VTABLE_elements(interp, args);
STRING * const open_bracket  = CONST_STRING(interp, "[");
STRING * const semi          = CONST_STRING(interp, ";");
STRING * const close_bracket = CONST_STRING(interp, "]");
STRING * const s_array       = CONST_STRING(interp, "array");
STRING *       prefix        = NULL;
STRING *       out           = open_bracket;

for (index = 0; index < elements; ++index) {
    PMC * const P0 = VTABLE_get_pmc_keyed_int(interp, args, index);

    if (!PMC_IS_NULL(P0)) {
        if (VTABLE_does(interp, P0, s_array)) {
            const INTVAL elements2 = VTABLE_elements(interp, P0);
            INTVAL index2;

            for (index2 = 0; index2 < elements2; ++index2) {
                STRING *S0   = VTABLE_get_string_keyed_int(interp, P0, index2);
                #line 513 "./src/pmc/codestring.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING_GEN(interp, "escape"), "S->S", S0, &S0);
#line 358 "./src/pmc/codestring.pmc"

                if (prefix)
                    out = Parrot_str_concat(interp, out, prefix);
                out    = Parrot_str_concat(interp, out, S0);
                prefix = semi;
            }
        }
        else {
            STRING *S0   = VTABLE_get_string_keyed_int(interp, args, index);
            #line 525 "./src/pmc/codestring.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING_GEN(interp, "escape"), "S->S", S0, &S0);
#line 367 "./src/pmc/codestring.pmc"

            if (prefix)
                out = Parrot_str_concat(interp, out, prefix);
            out    = Parrot_str_concat(interp, out, S0);
            prefix = semi;
        }
    }
}

out = Parrot_str_concat(interp, out, close_bracket);

#line 259 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *out */
#line 266 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "S", (STRING*)out);
    return;
    /*END RETURN STRING *out */
    }
#line 378 "./src/pmc/codestring.pmc"

#line 440 "/builddir/build/BUILD/parrot-2.10.1/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 555 "./src/pmc/codestring.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_CodeString_update_vtable(VTABLE *vt) {
    vt->init = Parrot_CodeString_init;
    vt->mark = Parrot_CodeString_mark;
    vt->attr_size = sizeof(Parrot_CodeString_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_CodeString_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->init = Parrot_CodeString_init;
    vt->mark = Parrot_CodeString_mark;
    vt->attr_size = sizeof(Parrot_CodeString_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_CodeString_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_String_get_vtable(interp);
    Parrot_CodeString_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_CodeString_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_String_ro_get_vtable(interp);
    Parrot_CodeString_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_CodeString_get_mro(PARROT_INTERP, ARGIN_NULLOK(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_String_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro,
        Parrot_str_new_init(interp, "CodeString", 10,
            Parrot_default_encoding_ptr, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_CodeString_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    isa = Parrot_String_get_isa(interp, isa);
    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "CodeString")), PMCNULL);
    return isa;
}

void
Parrot_CodeString_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Sstr_val Flinepos ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_CodeString_get_vtable(interp);
        vt->base_type      = enum_class_CodeString;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "CodeString");
        vt->provides_str = CONST_STRING_GEN(interp, "string");
        vt->isa_hash     = Parrot_CodeString_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_CodeString_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_CodeString;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_CodeString_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING *method_name = CONST_STRING_GEN(interp, "emit");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_CodeString_nci_emit),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "lineof");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_CodeString_nci_lineof),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "unique");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_CodeString_nci_unique),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "escape");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_CodeString_nci_escape),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "charname_to_ord");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_CodeString_nci_charname_to_ord),
                method_name, signature);
        }
        {
            STRING *method_name = CONST_STRING_GEN(interp, "key");
            STRING *signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_CodeString_nci_key),
                method_name, signature);
        }
        {
        }
    } /* pass */
} /* Parrot_CodeString_class_init */
#line 388 "./src/pmc/codestring.pmc"



/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
